/* JRm-hata.c
 *
 * Copyright 2001-2003 Vesa Halttunen (Vesuri/dA JoRMaS)
 *
 * This file is part of JRm-core.
 *
 * JRm-core is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * JRm-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JRm-core; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <string.h>
#include "JRm-hata.h"

buffer **pictures;
int renderwidth=400, renderheight=300, screenwidth=400, screenheight=300;
int savetodisk=0;
int npictures;
char *production_name="JRm-hata";
char *production_window_title="dA JoRMaS: Ht";
char *production_mp3_filename[]={
  "raunio.mp3"
};
int production_mp3_files=1;
int *production_mp3_volume;
long *production_mp3_time;
char *picture_filenames[]={
  "assembly.png",
  "colon.png",
  "2002.png",
  "helsinki.png",
  "shipyard1.jpg",
  "da.png",
  "jormas.png",
  "present.png",
  "factory1.jpg",
  "factory1.png",
  "design1.png",
  "design2.png",
  "crossplatform.png",
  "demo.png",
  "hata.png",
  "traffic1.jpg",
  "traffic2.jpg",
  "traffic3.jpg",
  "traffic4.jpg",
  "traffic5.jpg",
  "traffic6.jpg",
  "traffic7.jpg",
  "traffic8.jpg",
  "traffic.png",
  "jam.png",
  "instant.png",
  "mobility.png",
  "trafficbullshit1.png",
  "trafficbullshit2.png",
  "bullshitwhite.png",
  "bullshitblack.png",
  "train.jpg",
  "train.png",
  "straightelectric.png",
  "locomotives.png",
  "take.png",
  "you.png",
  "there.png",
  "but.png",
  "where.png",
  "factory2.jpg",
  "factory2small1.png",
  "factory2small2.png",
  "factory2small3.png",
  "energy.png",
  "crane1.jpg",
  "crane1small1.png",
  "crane1small2.png",
  "crane1small3.png",
  "machinery.png",
  "factory3.jpg",
  "factory3small1.png",
  "factory3small2.png",
  "factory3small3.png",
  "electricity.png",
  "traffic9.jpg",
  "traffic9small1.png",
  "traffic9small2.png",
  "traffic9small3.png",
  "technology.png",
  "laptop1.jpg",
  "laptop2.jpg",
  "laptop3.jpg",
  "laptop4.jpg",
  "laptop5.jpg",
  "laptop6.jpg",
  "laptop7.jpg",
  "laptop8.jpg",
  "laptop9.jpg",
  "laptop10.jpg",
  "laptop11.jpg",
  "laptop12.jpg",
  "laptop13.jpg",
  "laptop14.jpg",
  "laptop15.jpg",
  "laptop16.jpg",
  "motherboard.jpg",
  "mobile.png",
  "computing.png",
  "whenever.png",
  "whereever.png",
  "phone.jpg",
  "phonebox.png",
  "globalcoverage.png",
  "factory4.jpg",
  "factory4small1.png",
  "factory4small2.png",
  "factory4small3.png",
  "crane2.jpg",
  "crane2small1.png",
  "crane2small2.png",
  "crane2small3.png",
  "powerstation.jpg",
  "powerstationsmall1.png",
  "powerstationsmall2.png",
  "powerstationsmall3.png",
  "traffic10.jpg",
  "traffic10small1.png",
  "traffic10small2.png",
  "traffic10small3.png",
  "fuel1.jpg",
  "fuel2.jpg",
  "fuel3.jpg",
  "fuel4.jpg",
  "fuel5.jpg",
  "fuel6.jpg",
  "fuel7.jpg",
  "fuel8.jpg",
  "fuel9.jpg",
  "technology2.png",
  "possibility.png",
  "answer.png",
  "problems.png",
  "binary.png",
  "eye.jpg",
  "what.png",
  "about.png",
  "the.png",
  "problems2.png",
  "ofthe.png",
  "mind.png",
  "stairs1.jpg",
  "stairs2.jpg",
  "stairs3.jpg",
  "stairs4.jpg",
  "stairs5.jpg",
  "stairs6.jpg",
  "stairs7.jpg",
  "stairs8.jpg",
  "stairs9.jpg",
  "stairs10.jpg",
  "stairs11.jpg",
  "stairs12.jpg",
  "stairs13.jpg",
  "stairs14.jpg",
  "stairs15.jpg",
  "fear.png",
  "insecurity.png",
  "loneliness.png",
  "insanity.png",
  "basement1.jpg",
  "basement2.jpg",
  "basement3.jpg",
  "basement4.jpg",
  "basement5.jpg",
  "basement6.jpg",
  "basement7.jpg",
  "basement8.jpg",
  "basement9.jpg",
  "basement10.jpg",
  "basement11.jpg",
  "basement12.jpg",
  "basement13.jpg",
  "basement14.jpg",
  "basement15.jpg",
  "elevator1.jpg",
  "elevator2.jpg",
  "elevator3.jpg",
  "elevator4.jpg",
  "elevator5.jpg",
  "elevator6.jpg",
  "elevator7.jpg",
  "elevator8.jpg",
  "elevator9.jpg",
  "vesuri1.jpg",
  "vesuri2.jpg",
  "vesuri3.jpg",
  "vesuri4.jpg",
  "vesuri5.jpg",
  "vesuri6.jpg",
  "vesuri7.jpg",
  "vesuri8.jpg",
  "lapinkulta.jpg",
  "lapinkultasmall1.png",
  "lapinkultasmall2.png",
  "lapinkultasmall3.png",
  "lapinkultasmall4.png",
  "lapinkultasmall5.png",
  "lapinkultasmall6.png",
  "lapinkultasmall7.png",
  "lapinkultasmall8.png",
  "lapinkultasmall9.png",
  "lapinkultasmall10.png",
  "lapinkultasmall11.png",
  "lapinkultasmall12.png",
  "beer.jpg",
  "water1.jpg",
  "water2.jpg",
  "water3.jpg",
  "water4.jpg",
  "peaceofmind.png",
  "escapingreality.png",
  "help1.jpg",
  "help2.jpg",
  "help3.jpg",
  "help4.jpg",
  "credits.png",
  "kode.png",
  "gfx.png",
  "musik.png",
  "design.png",
  "vesuri.png",
  "thanks.png",
  "inspiration.png",
  "gmunk.png",
  "lievonen.png",
  "support.png",
  "virnes.png",
  "jrm.png",
  "design3.png",
  "design4.png",
  "design5.jpg",
  "design6.jpg",
  "design7.jpg",
  "design8.jpg",
  "symbol.png",
  "mixer1.jpg",
  "mixer2.jpg",
  "mixer3.jpg",
  "mixer4.jpg",
  "eps.jpg",
  "x51.jpg",
  "x52.jpg",
  "endscreen.png",
  NULL
};

/* Allocate a temporary buffer and load pictures */
void production_startup() {
  int i=0;

  production_mp3_volume=(int *)calloc(production_mp3_files, sizeof(int));
  production_mp3_time=(long *)calloc(production_mp3_files, sizeof(long));
  production_mp3_volume[0]=256;

  while(picture_filenames[i]!=NULL)
    i++; 
  npictures=i+1;
  pictures=(struct buffer **)calloc(npictures, sizeof(struct buffer *));

  i=0;
  while(picture_filenames[i]!=NULL) {
    char *filename;
#ifdef DATADIR_PREFIX
    filename=(char *)calloc(strlen(DATADIR_PREFIX)+1+
			    strlen(production_name)+1+
			    strlen(picture_filenames[i])+1, sizeof(char));
    sprintf(filename, "%s/%s/%s", DATADIR_PREFIX, production_name,
	    picture_filenames[i]);
    if(!(pictures[i]=buffer_load(filename))) {
      free(filename);
#endif
      filename=(char *)calloc(strlen("data/")+strlen(picture_filenames[i])+1,
			      sizeof(char));
      sprintf(filename, "data/%s", picture_filenames[i]);
      if(!(pictures[i]=buffer_load(filename))) {
#ifdef DATADIR_PREFIX
	fprintf(stderr, "Couldn't load %s/%s/%s or data/%s\n",
		DATADIR_PREFIX, production_name, picture_filenames[i],
		picture_filenames[i]);
#else
	fprintf(stderr, "Couldn't load data/%s\n", picture_filenames[i]);
#endif
	exit(1);
      }
#ifdef DATADIR_PREFIX
    }
#endif
    i++;
  }
  pictures[i]=buffer_new(renderwidth, renderheight);
}

void production_shutdown() {
  int i;

  if(effectlist)
    effectlist_free(effectlist);
  effectlist=NULL;

  for(i=0; i<npictures; i++)
    buffer_free(pictures[i]);
  free(pictures);
  free(production_mp3_time);
  free(production_mp3_volume);
}

timelineentry timeline[] = {
  { PART_01_START, part_01 },
  /* Pattern 02 is handled in part 01 */
  { PART_03_START, part_03 },
  /* Pattern 04 is handled in part 03 */
  { PART_05_START, part_05 },
  /* Pattern 06 is handled in part 05 */
  { PART_07_START, part_07 },
  /* Pattern 08 is handled in part 07 */
  { PART_09_START, part_09 },
  /* Pattern 10 is handled in part 09 */
  { PART_11_START, part_11 },
  /* Pattern 12 is handled in part 11 */
  { PART_13_START, part_13 },
  { PART_14_START, part_14 },
  { PART_15_START, part_15 },
  { PART_16_START, part_16 },
  { PART_17_START, part_17 },
  /* Pattern 18 is handled in part 17 */
  { PART_19_START, part_19 },
  /* Pattern 20 is handled in part 19 */
  { PART_21_START, part_21 },
  { PART_22_START, part_22 },
  { PART_23_START, part_23 },
  { PART_24_START, part_24 },
  { PART_25_START, part_25 },
  /* Pattern 26 is handled in part 25 */
  { PART_27_START, part_27 },
  /* Pattern 28 is handled in part 27 */
  { PART_29_START, part_29 },
  /* Pattern 30 is handled in part 29 */
  { PART_31_START, part_31 },
  /* Pattern 32 is handled in part 31 */
  { PART_33_START, part_33 },
  /* Pattern 34 is handled in part 33 */
  { PART_35_START, part_35 },
  /* Pattern 36 is handled in part 35 */
  { PART_37_START, part_37 },
  /* Patterns 38-40 are handled in part 37 */
  { PART_41_START, part_41 },
  /* Patterns 42-44 are handled in part 41 */
  { PART_45_START, part_45 },
  /* Pattern 46 is handled in part 45 */
  { PART_END, production_quit },
  { NULL, NULL }
};
